<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.test.lingproc.test_text_parser &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.test.lingproc.test_text_parser</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.test.lingproc.test_text_parser</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">nl2declare.lingproc.text_parser</span> <span class="kn">import</span> <span class="n">TextParser</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.interrelation</span> <span class="kn">import</span> <span class="n">Interrelation</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.action</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.relation_type</span> <span class="kn">import</span> <span class="n">RelationType</span>

<span class="c1"># def test_text_parser_approval(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;The approval of the claim should be preceded by the creation of an invoice.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;The approval of the claim&#39;, &#39;the creation of an invoice&#39;]&quot; in captured.out</span>
<span class="c1">#     assert &quot;Action:   the approval of the claim&quot; in captured.out</span>
<span class="c1">#     assert &quot;Action:   the creation of an invoice&quot; in captured.out</span>
<span class="c1">#     assert &quot;Interrelation [A=Action:   the creation of an invoice, B=Action:   the approval of the claim, type=RelationType.FOLLOWS]&quot; in captured.out</span>

<span class="c1"># def test_text_parser_process_starts(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;The process starts when an invoice is received by the administration department.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;The process&#39;, &#39;an invoice&#39;, &#39;the administration department&#39;]&quot; in captured.out</span>

<span class="c1"># def test_text_parser_activity_system(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;After each of these activities, the proper system functionality is tested.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;these activities&#39;, &#39;the proper system functionality&#39;]&quot; in captured.out</span>

<span class="c1"># def test_text_parser_man_order(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;The man creates an order.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;The man&#39;, &#39;an order&#39;]&quot; in captured.out</span>

<span class="c1"># def test_text_parser_creation_claim(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;A creation of a claim precedes creation of document.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;A creation of a claim&#39;, &#39;creation of document&#39;]&quot; in captured.out</span>

<span class="c1"># def test_text_parser_claim_rejected(capsys):</span>
<span class="c1">#     text_parser = TextParser()</span>
<span class="c1">#     text_parser.parse_constraint_string(&quot;Once a claim has been rejected, it should not be paid out.&quot;)</span>
<span class="c1">#     captured = capsys.readouterr()</span>
<span class="c1">#     assert &quot;Noun Phrases: [&#39;it&#39;, &#39;a claim&#39;]&quot; in captured.out</span>



<span class="c1">#new tests</span>

<div class="viewcode-block" id="test_text_parser_two_mandatory_verbs"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_two_mandatory_verbs">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_two_mandatory_verbs</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;A claim must be created before an invoice must be sent.&quot;</span><span class="p">)</span>
    <span class="n">all_interrelations</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
        <span class="n">all_interrelations</span> <span class="o">=</span> <span class="n">all_interrelations</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Interrelation [A=Action: create claim, B=Action: send invoice, type=RelationType.FOLLOWS]&quot;</span> <span class="ow">in</span> <span class="n">all_interrelations</span> </div>


<div class="viewcode-block" id="test_text_parser_change_direction"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_change_direction">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_change_direction</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;A claim must be created after an invoice is sent.&quot;</span><span class="p">)</span>
    <span class="n">all_interrelations</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
        <span class="n">all_interrelations</span> <span class="o">=</span> <span class="n">all_interrelations</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Interrelation [A=Action: send invoice, B=Action: create claim, type=RelationType.FOLLOWS]&quot;</span> <span class="ow">in</span> <span class="n">all_interrelations</span></div>

<div class="viewcode-block" id="test_text_parser_passive_required_form"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_passive_required_form">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_passive_required_form</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;Sending an invoice is required to create a claim.&quot;</span><span class="p">)</span>
    <span class="n">all_interrelations</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
        <span class="n">all_interrelations</span> <span class="o">=</span> <span class="n">all_interrelations</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Interrelation [A=Action: send invoice, B=Action: create claim, type=RelationType.FOLLOWS]&quot;</span> <span class="ow">in</span> <span class="n">all_interrelations</span></div>
 
<div class="viewcode-block" id="test_text_parser_is_preceded"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_is_preceded">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_is_preceded</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;Sending an invoice is preceded by creating a claim.&quot;</span><span class="p">)</span>
    <span class="n">all_interrelations</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
      <span class="n">all_interrelations</span> <span class="o">=</span> <span class="n">all_interrelations</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Interrelation [A=Action: create claim, B=Action: send invoice, type=RelationType.FOLLOWS]&quot;</span> <span class="ow">in</span> <span class="n">all_interrelations</span></div>

<div class="viewcode-block" id="test_text_parser_proper_noun_flat"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_proper_noun_flat">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_proper_noun_flat</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;A claim must be created before an invoice must be sent to Boris Johannes Schmitz.&quot;</span><span class="p">)</span>
    <span class="n">all_interrelations</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">interrelations</span><span class="p">:</span>
        <span class="n">all_interrelations</span> <span class="o">=</span> <span class="n">all_interrelations</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Interrelation [A=Action: create claim, B=Action: send invoice, type=RelationType.FOLLOWS]&quot;</span> <span class="ow">in</span> <span class="n">all_interrelations</span> </div>

<div class="viewcode-block" id="test_text_parser_empty_model"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_empty_model">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_empty_model</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;Test&quot;</span><span class="p">)</span>
    <span class="n">all_actions</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">actions</span><span class="p">:</span>
        <span class="n">all_actions</span> <span class="o">=</span> <span class="n">all_actions</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Action: test&quot;</span> <span class="ow">in</span> <span class="n">all_actions</span> </div>

<div class="viewcode-block" id="test_text_parser_one_action"><a class="viewcode-back" href="../../../../nl2declare.test.lingproc.html#nl2declare.test.lingproc.test_text_parser.test_text_parser_one_action">[docs]</a><span class="k">def</span> <span class="nf">test_text_parser_one_action</span><span class="p">(</span><span class="n">capsys</span><span class="p">):</span>
    <span class="n">text_parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">text_parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="s2">&quot;Creating an invoice.&quot;</span><span class="p">)</span>
    <span class="n">all_actions</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">result</span><span class="o">.</span><span class="n">actions</span><span class="p">:</span>
        <span class="n">all_actions</span> <span class="o">=</span> <span class="n">all_actions</span> <span class="o">+</span> <span class="n">i</span><span class="o">.</span><span class="fm">__str__</span><span class="p">()</span>
    <span class="k">assert</span> <span class="s2">&quot;Action: create invoice&quot;</span> <span class="ow">in</span> <span class="n">all_actions</span> </div>



</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>